#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	angle = 0.5;
	scalar = 100;
	speed = 0;
	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 200; i++){
		particle myParticle;
		
		float x = 500 + 100 * cos ( (i / 200.0) * TWO_PI);
		float y = 500 + 100 * sin ( (i / 200.0) * TWO_PI);
		
		myParticle.setInitialCondition(x,y ,0,0);
		particles.push_back(myParticle);
	}
	
	// change this to
	// for (int i = 0; i < 10; i++){
	// to see a chain
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 2;
		mySpring.springiness	= 0.5f;
		mySpring.particleA = & (particles[i  ]);
		mySpring.particleB = & (particles[(i+1) % particles.size()]);
		springs.push_back(mySpring);
	}
	
		
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
//	angle += speed;
//	wave = sin (angle + ofGetElapsedTimef()*2);
	
	
	float mouseSin = ofMap(sin(ofGetElapsedTimef()*2), -1,1,0,500); 
	float mouseSin2 = ofMap(sin(ofGetElapsedTimef()*3), -1,1,0,500);	
	for (int i = 0; i < particles.size(); i++){
		
		
		particles[i].addRepulsionForce(mouseX, mouseY, mouseSin, 2.7f);
		particles[i].addClockwiseForce(particles[i], 500, 1.5);
		
		particles[i].addAttractionForce(mouseX, mouseY, mouseSin2, 0.5f);
		
		
		for (int j = 0; j < i; j++){
			
			wave = sin (ofGetElapsedTimef()*2);
			
			particles[i].addRepulsionForce(particles[j], 100, 0.5);
			particles[i].addAttractionForce(particles[j], 50, 0.05);

			particles[i].addCounterClockwiseForce(particles[j], 200, 0.09);
			particles[i].addClockwiseForce(particles[j], 1000, 0.0015);

			

		}
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	
	wave = sin (ofGetElapsedTimef()*2) + scalar;
	
	ofSetColor(255,100,100);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
		
		ofSetColor(240,50,0,100);
		ofSetLineWidth(1);
		ofLine(particles[i].pos.x , particles[i].pos.y, particles[i].pos.x + 100, particles[i].pos.y+ wave);

		
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].draw();
	}


	
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles[0].pos.set(mouseX, mouseY);
//	particles.erase(particles.begin());
//	particle myParticle;
//	myParticle.setInitialCondition(x,y,0,0);
//	particles.push_back(myParticle);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
	particles[0].bFixed = false;
}

